/***************************************************************************
 *   Copyright (C) 2007 by Pelladi Gabor   *
 *   pelladigabor@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#pragma once

typedef unsigned char pos_T;
const pos_T max_table_size = 25;

// parameters
extern pos_T table_size;
extern int start_depth;
extern int max_depth;
extern int depth_increment;
extern unsigned int max_branch;
extern bool force_thinking;

// interrupt
extern bool cancelling;

struct Field {
	pos_T x, y;
	Field() : x(0), y(0) {}
	Field(pos_T x0, pos_T y0) : x(x0), y(y0) {}
	bool operator==(const Field& field) {return x == field.x && y == field.y;}
};

// perform global initialization, calling externally is optional, called internally on first game
void ai_init();
// perform global cleanup
void ai_end();
// a new game has started
void ai_new_game();
// the current player made a step
void ai_step(pos_T x, pos_T y);
// the server made a step
void ai_step_server(pos_T x, pos_T y);
// suggest a move for the current player
Field ai_think();
